﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public int connection = DMcLgLCD.LGLCD_INVALID_CONNECTION;
        public int device = DMcLgLCD.LGLCD_INVALID_DEVICE;
        public int deviceType = DMcLgLCD.LGLCD_INVALID_DEVICE;

        private uint buttons = 0;
        private int config = 0;
        private int cnt = 0;
        private bool direction = false;

        Form2 form2;

        Bitmap LCD;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if (DMcLgLCD.ERROR_SUCCESS == DMcLgLCD.LcdInit())
            {
                connection = DMcLgLCD.LcdConnectEx("C# Example", 0, 0);

                if (DMcLgLCD.LGLCD_INVALID_CONNECTION != connection)
                {
                    device = DMcLgLCD.LcdOpenByType(connection, DMcLgLCD.LGLCD_DEVICE_QVGA);

                    if (DMcLgLCD.LGLCD_INVALID_DEVICE == device)
                    {
                        device = DMcLgLCD.LcdOpenByType(connection, DMcLgLCD.LGLCD_DEVICE_BW);
                        if (DMcLgLCD.LGLCD_INVALID_DEVICE != device)
                        {
                            deviceType = DMcLgLCD.LGLCD_DEVICE_BW;
                        }
                    }
                    else
                    {
                        deviceType = DMcLgLCD.LGLCD_DEVICE_QVGA;
                    }

                    if (DMcLgLCD.LGLCD_DEVICE_BW == deviceType)
                    {
                        LCD = new Bitmap(160, 43);
                        Graphics g = Graphics.FromImage(LCD);
                        g.Clear(Color.White);
                        g.Dispose();

                        DMcLgLCD.LcdUpdateBitmap(device, LCD.GetHbitmap(), DMcLgLCD.LGLCD_DEVICE_BW);
                        DMcLgLCD.LcdSetAsLCDForegroundApp(device, DMcLgLCD.LGLCD_FORE_YES);

                        pictureBox1.Width = 160;
                        pictureBox1.Height = 43;
                        
                    }
                    else
                    {
                        LCD = new Bitmap(320, 240);
                        Graphics g = Graphics.FromImage(LCD);
                        g.Clear(Color.White);
                        g.Dispose();

                        DMcLgLCD.LcdUpdateBitmap(device, LCD.GetHbitmap(), DMcLgLCD.LGLCD_DEVICE_QVGA);
                        DMcLgLCD.LcdSetAsLCDForegroundApp(device, DMcLgLCD.LGLCD_FORE_YES);

                        pictureBox1.Width = 320;
                        pictureBox1.Height = 240;
                    }

                    if (deviceType > 0)
                    {
                        //commented out in favor of polling routine.
                        //DMcLgLCD.LcdSetButtonCallback(btnCallback);
                        DMcLgLCD.LcdSetConfigCallback(cfgCallback);
                        //The fastest you should send updates to the LCD is around 30fps or 34ms.  100ms is probably a good typical update speed.
                        timer1.Interval = 40;
                        timer1.Enabled = true;
                    }
                }
            }
        }


        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            LCD.Dispose();
            DMcLgLCD.LcdClose(device);
            DMcLgLCD.LcdDisconnect(connection);
            DMcLgLCD.LcdDeInit();
        }

        //Not used in this example
        public void btnCallback(int deviceType, int dwButtons)
        {
            buttons = (uint)dwButtons;
        }

        public void cfgCallback(int cfgConnection)
        {
            config = cfgConnection;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Font sFont;
            
            
            if (config == connection)
            {
                if (null == form2)
                {
                    form2 = new Form2();
                }
                form2.Show();
                config = 0;
            }

            if (null==form2 || !form2.Visible)
            {

                Graphics g = Graphics.FromImage(LCD);
                g.Clear(Color.White);
                g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAliasGridFit;

                if (DMcLgLCD.LGLCD_DEVICE_BW == deviceType)
                    sFont = new Font("Arial", 7, FontStyle.Regular);
                else
                    sFont = new Font("Arial", 14, FontStyle.Regular);

                buttons = DMcLgLCD.LcdReadSoftButtons(device);

                if ((buttons & DMcLgLCD.LGLCD_BUTTON_1) == DMcLgLCD.LGLCD_BUTTON_1)
                    drawCircleText(g, 10, 27, 5, "1", sFont, Brushes.Black);
                if ((buttons & DMcLgLCD.LGLCD_BUTTON_2) == DMcLgLCD.LGLCD_BUTTON_2)
                    drawCircleText(g, 40, 27, 5, "2", sFont, Brushes.Black);
                if ((buttons & DMcLgLCD.LGLCD_BUTTON_3) == DMcLgLCD.LGLCD_BUTTON_3)
                    drawCircleText(g, 80, 27, 5, "3", sFont, Brushes.Black);
                if ((buttons & DMcLgLCD.LGLCD_BUTTON_4) == DMcLgLCD.LGLCD_BUTTON_4)
                    drawCircleText(g, 110, 27, 5, "4", sFont, Brushes.Black);

                if ((buttons & DMcLgLCD.LGLCD_BUTTON_LEFT) == DMcLgLCD.LGLCD_BUTTON_LEFT)
                    drawCircleText(g, 100, 120, 15, "L", sFont, Brushes.Black);
                if ((buttons & DMcLgLCD.LGLCD_BUTTON_RIGHT) == DMcLgLCD.LGLCD_BUTTON_RIGHT)
                    drawCircleText(g, 220, 120, 15, "R", sFont, Brushes.Black);
                if ((buttons & DMcLgLCD.LGLCD_BUTTON_UP) == DMcLgLCD.LGLCD_BUTTON_UP)
                    drawCircleText(g, 160, 60, 15, "U", sFont, Brushes.Black);
                if ((buttons & DMcLgLCD.LGLCD_BUTTON_DOWN) == DMcLgLCD.LGLCD_BUTTON_DOWN)
                    drawCircleText(g, 160, 180, 15, "D", sFont, Brushes.Black);

                if ((buttons & DMcLgLCD.LGLCD_BUTTON_MENU) == DMcLgLCD.LGLCD_BUTTON_MENU)
                    drawCircleText(g, 100, 180, 15, "M", sFont, Brushes.Black);
                if ((buttons & DMcLgLCD.LGLCD_BUTTON_OK) == DMcLgLCD.LGLCD_BUTTON_OK)
                    drawCircleText(g, 160, 120, 15, "OK", sFont, Brushes.Black);
                if ((buttons & DMcLgLCD.LGLCD_BUTTON_CANCEL) == DMcLgLCD.LGLCD_BUTTON_CANCEL)
                    drawCircleText(g, 220, 180, 15, "<=", sFont, Brushes.Black);


                if (!direction)
                {
                    cnt += 1;
                    if (cnt > 25)
                    {
                        direction = !direction;
                        cnt = 25;
                    }
                }
                else
                {
                    cnt -= 1;
                    if (cnt < 1)
                    {
                        direction = !direction;
                        cnt = 1;
                    }
                }

                String str = new String('=', cnt);

                if (DMcLgLCD.LGLCD_DEVICE_BW == deviceType)
                {
                    g.DrawString("This is a test", sFont, SystemBrushes.WindowText, 0, 0);
                    g.DrawString("Line 2", sFont, Brushes.Black, 0, 10);
                    g.DrawString(str, sFont, Brushes.Black, 0, 32);
                    DMcLgLCD.LcdUpdateBitmap(device, LCD.GetHbitmap(), DMcLgLCD.LGLCD_DEVICE_BW);
                }
                else
                {
                    g.DrawString("This is a test", sFont, Brushes.Red, 0, 0);
                    g.DrawString("Line 2", sFont, Brushes.DarkBlue, 0, 20);
                    g.DrawString(str, sFont, Brushes.Red, 0, 40);
                    DMcLgLCD.LcdUpdateBitmap(device, LCD.GetHbitmap(), DMcLgLCD.LGLCD_DEVICE_QVGA);
                }

                pictureBox1.Image = LCD;

                sFont.Dispose();
                g.Dispose();
            }
            

        }

        private void drawCircleText(Graphics g, int x, int y, int r, string txt, Font fnt, Brush brush)
        {
            //make circle with radius r and center at x, y
            Rectangle rec = new Rectangle(x-r, y-r, r*2, r*2);
            Pen p = new Pen(brush);
            g.DrawEllipse(p, rec);

            SizeF txtSize = g.MeasureString(txt, fnt);
            g.DrawString(txt, fnt, brush, x - (txtSize.Width / 2) + 1, y - (txtSize.Height / 2) + 1);

            p.Dispose();
        }

    }
}
